import { Observable } from 'rxjs';

import { WindowState } from '../types/window-state.type';
import { WindowIdle } from '../types/window-idle.type';
import { NotificationRequest } from '../models/notification';
import { TranslateLoader } from '@ngx-translate/core';

export interface NativeService {
  postAppInit(): void;

  notify(noti: NotificationRequest): void;
  closeAllNotify(): void;

  checkForUpdates(): Observable<boolean>;

  showImageViewer(): void;

  saveFile(buffer: Buffer, fileName: string, path?: string): Observable<string>;
  readFile(path: string): Observable<Buffer>;

  windowStateChanged(): Observable<WindowState>;
  windowClose(): void;
  windowMinimize(): void;
  windowMaximize(): void;

  idleStateChanged(): Observable<WindowIdle>;

  chatOpenRoom(): Observable<string>;

  getTranslateLoader(prefix?: string, suffix?: string): TranslateLoader;
}
